using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;

namespace InterfaceKit
{
    public delegate void SetSensorDelegate(int value, int sensor);

    public partial class PhidgetInterfaceKitForm : Form
    {
        ArrayList trackBarList;
        ArrayList labelList;

        #region constructor

        public PhidgetInterfaceKitForm()
        {
            InitializeComponent();
            trackBarList = new ArrayList();
            trackBarList.Add(trackBar0);
            trackBarList.Add(trackBar1);
            trackBarList.Add(trackBar2);
            trackBarList.Add(trackBar3);
            trackBarList.Add(trackBar4);
            trackBarList.Add(trackBar5);
            trackBarList.Add(trackBar6);
            trackBarList.Add(trackBar7);

            labelList = new ArrayList();
            labelList.Add(label0);
            labelList.Add(label1);
            labelList.Add(label2);
            labelList.Add(label3);
            labelList.Add(label4);
            labelList.Add(label5);
            labelList.Add(label6);
            labelList.Add(label7);

        }

        #endregion


        #region methods
        public void phidgetInterfaceKit_init()
        {
            Console.WriteLine("phidgetInterfaceKit_init()");
        }
        #endregion


        #region PhidgetEvent

        private void PhidgetInterfaceKitForm_Load(object sender, EventArgs e)
        {

        }

        /// <summary>
        /// PhidgetInterfaceKit ڑ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void interfaceKit_Attach(object sender, EventArgs e)
        {
            Console.WriteLine("InterfaceKit: Attach");
            this.phidgetInterfaceKit_init();
        }


        /// <summary>
        /// PhidgetInterfaceKit ڑ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void interfaceKit_Detach(object sender, EventArgs e)
        {
            Console.WriteLine("InterfaceKit: Detach");
        }


        /// <summary>
        /// PhidgetInterfaceKit fW^͒lς
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void interfaceKit_InputChange(object sender, GroupLab.Phidgets.BitStateChangeEventArgs e)
        {
            Console.WriteLine("InterfaceKit: InputChange");
        }


        /// <summary>
        /// PhidgetInterfaceKit fW^o͒lς
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void interfaceKit_OutputChange(object sender, GroupLab.Phidgets.BitStateChangeEventArgs e)
        {
            Console.WriteLine("InterfaceKit: OutputChange");
        }


        /// <summary>
        /// PhidgetInterfaceKit AiO͒l(ZT[)ς
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void interfaceKit_SensorChange(object sender, GroupLab.Phidgets.IndexSensorChangeEventArgs e)
        {
            Console.WriteLine("InterfaceKit: SensorChange");
            Console.WriteLine("  " + interfaceKit.Sensors[7].Value.ToString());
            showSensorValue(e.Value, e.Index);
        }

        #endregion


        #region UI methods

        public void showSensorValue(int value, int sensor)
        {
            SetSensorDelegate s_delegate = setTrackBarValue;
            try
            {
                this.Invoke(s_delegate, value, sensor);
            }
            catch { }
        }

        /// <summary>
        /// showSensorValueinvokeŌĂ΂
        /// </summary>
        /// <param name="value"></param>
        /// <param name="sensor"></param>
        private void setTrackBarValue(int value, int sensor)
        {
            ((TrackBar)trackBarList[sensor]).Value = value;
            ((Label)labelList[sensor]).Text = sensor.ToString() + ": " + value.ToString();
        }

        #endregion

    }
}